/**
 * Copyright (C) 2008 Gauvain Pocentek <gpocentek@linutop.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LTOP_MEDIA_H__
#define __LTOP_MEDIA_H__

#include <glib-object.h>
#include <gdk/gdk.h>

#define LTOP_TYPE_MEDIA            (ltop_media_get_type ())
#define LTOP_MEDIA(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), LTOP_TYPE_MEDIA, LtopMedia))
#define LTOP_IS_MEDIA(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LTOP_TYPE_MEDIA))
#define LTOP_MEDIA_GET_IFACE(inst) (G_TYPE_INSTANCE_GET_INTERFACE ((inst), LTOP_TYPE_MEDIA, LtopMediaInterface))

typedef struct _LtopMedia LtopMedia; /* dummy object */
typedef struct _LtopMediaInterface LtopMediaInterface;

struct _LtopMediaInterface {
  GTypeInterface parent;

  /* methods */
  void (*attach_to_window) (LtopMedia *media, GdkWindow *window);
  void (*run)              (LtopMedia *media);

  /* signals */
  void (*job_done)         (LtopMedia *media);
};

GType ltop_media_get_type        (void) G_GNUC_CONST;

void ltop_media_attach_to_window (LtopMedia *media,
                                  GdkWindow *window);
void ltop_media_run              (LtopMedia *media);

void ltop_media_job_done         (LtopMedia *media);

#endif /* __LTOP_MEDIA_H__ */

