/**
 * Copyright (C) 2008 Gauvain Pocentek <gpocentek@linutop.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LTOP_PLAYER_H__
#define __LTOP_PLAYER_H__

#include <gtk/gtk.h>

G_BEGIN_DECLS

typedef struct _LtopPlayerPrivate LtopPlayerPrivate;
typedef struct _LtopPlayerClass   LtopPlayerClass;
typedef struct _LtopPlayer        LtopPlayer;

#define LTOP_TYPE_PLAYER             (ltop_player_get_type ())
#define LTOP_PLAYER(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), LTOP_TYPE_PLAYER, LtopPlayer))
#define LTOP_PLAYER_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), LTOP_TYPE_PLAYER, LtopPlayerClass))
#define LTOP_IS_PLAYER(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LTOP_TYPE_PLAYER))
#define LTOP_IS_PLAYER_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), LTOP_TYPE_PLAYER))
#define LTOP_PLAYER_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), LTOP_TYPE_PLAYER, LtopPlayerClass))

struct _LtopPlayerClass
{
  GtkWidgetClass __parent__;

  /* signals */
  void (* next_item)   (GtkWidget *LtopPlayer);
  void (* end_reached) (GtkWidget *LtopPlayer);
};

struct _LtopPlayer
{
  GtkWidget __parent__;

  /*< private >*/
  LtopPlayerPrivate *priv;
};

GType      ltop_player_get_type (void) G_GNUC_CONST G_GNUC_INTERNAL;

GtkWidget *ltop_player_new       (const gchar *filename) G_GNUC_MALLOC G_GNUC_INTERNAL;
void       ltop_player_run       (LtopPlayer *player);
void       ltop_player_play_next (LtopPlayer *player);

G_END_DECLS

#endif /* __LTOP_PLAYER_H__ */
